#define DMABUFFERSIZE   4096
#define	MAXDMABUFFERS	4

#define	_ES_CHANNEL0	0
#define	_ES_CHANNEL1	1

#define _MAX_DIG_CHANNELS   2

#define FAILMARK    'X'
#define CHECKMARK (unsigned char) 251

/* Board Test Version Number */
#ifdef	_DEBUG
	#define _BT_VERSION     _BT_MAJOR "." _BT_MINOR "." _BT_BUILD
#else
	#define _BT_VERSION     _BT_MAJOR "." _BT_MINOR
#endif	

#define _BT_TITLE   _CHIPNAME " Auto Board Test v" _BT_VERSION

/* Define constants for joystick test line */
#define JOYLEN                          999

#define _CONFIG_FILE_NAME    "hardware.cfg"

#define	_COPYRIGHT			"Copyright(c) 1997,1998 ESS Technology Ltd."

/*****************************************************************************/
/* ESS AudioDrive Chip Type                                                  */
/*****************************************************************************/
#define _CHIPTYPE    0x1938
#define _CHIPNAME    "Solo-1"

/*****************************************************************************/
/* Board Test Version & Build Number                                         */
/*****************************************************************************/
#define _BT_MAJOR       "1"
#define _BT_MINOR       "03"
#define _BT_BUILD       "00"

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
#define	DEFAULT_IO_PCI			0x4000
#define DEFAULT_IO_AUDIO  		0x0220

#define DEFAULT_IO_FMSYNTH		0x0388
#define	DEFAULT_IO_JOYSTICK		0x0201
#define DEFAULT_IO_MPU401   	0x0330

#define DEFAULT_IRQ_AUDIO     	9

#define	DEFAULT_IRQ_MPU401		DEFAULT_IRQ_AUDIO

#define	DEFAULT_MONOIN_TOLERANCE	10
#define	DEFAULT_MIC_TOLERANCE		10
#define	DEFAULT_LINEIN_TOLERANCE    10
#define	DEFAULT_CDLINEIN_TOLERANCE  10
#define DEFAULT_JOYSTICK_TOLERANCE  20

#define DEFAULT_MONOIN_FREQUENCY    220
#define DEFAULT_MIC_FREQUENCY       220
#define DEFAULT_LINEIN_FREQUENCY    220
#define DEFAULT_CDLINEIN_FREQUENCY  220

#define DEFAULT_MASTER_VOLUME_L     0x3F
#define DEFAULT_MASTER_VOLUME_R     0x3F

#define	DEFAULT_WAVEIN_VOLUME_R		0x09
#define	DEFAULT_WAVEIN_VOLUME_L		0x09

#define DEFAULT_WAVEOUT_VOLUME_R    0x09
#define DEFAULT_WAVEOUT_VOLUME_L    0x09

#define	DEFAULT_MONOIN_VOLUME_R		0x09
#define DEFAULT_MONOIN_VOLUME_L    	0x09

#define	DEFAULT_FMSYNTH_VOLUME_L	0x09
#define	DEFAULT_FMSYNTH_VOLUME_R	0x09

#define	DEFAULT_MIC_VOLUME_R		0x09
#define	DEFAULT_MIC_VOLUME_L		0x09
		                               
#define	DEFAULT_LINEIN_VOLUME_R		0x09
#define	DEFAULT_LINEIN_VOLUME_L		0x09

#define	DEFAULT_CDLINEIN_VOLUME_R	0x09
#define	DEFAULT_CDLINEIN_VOLUME_L	0x09


#define	DEFAULT_LOG_FILENAME	"PRN"
/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
extern	LPBYTE	glpLogFileName;

extern WORD     gwChipType;

extern WORD     gwIOPCI,
				gwIODMA[],
				gwIOAudio,
				gwIOMPU401,
				gwIOFMSynth,
				gwIOJoystick;

extern BYTE     gbIRQAudio;

extern BYTE		gbMonoInTolerance,
				gbMicTolerance,
				gbLineInTolerance,
                gbCDLineInTolerance,
                gbJoystickTolerance;

extern WORD		gwMonoInFrequency,
				gwMicFrequency,
				gwLineInFrequency,
				gwCDLineInFrequency;
					
extern BYTE		gbMasterVolumeR,
				gbMasterVolumeL,
				gbWaveInVolumeR,
				gbWaveInVolumeL,
				gbWaveOutVolumeR,
				gbWaveOutVolumeL,
				gbMonoInVolumeL,
				gbMonoInVolumeR,
				gbFMSynthVolumeL,
				gbFMSynthVolumeR,
				gbMicVolumeR,
				gbMicVolumeL,
				gbLineInVolumeR,
				gbLineInVolumeL,
				gbCDLineInVolumeR,
				gbCDLineInVolumeL;
											
extern BYTE     flgAutoMode,
				flgTestMic,
				flgTestLineIn,
				flgTestCDLineIn,
				flgTestJoystick,
				flgTestMPU401,
				flgTestMonoIn;

extern  int     _io_pci_choices[];
extern  int     _io_audio_choices[];
extern  int     _irq_audio_choices[];
extern	int		_io_fmsynth_choices[];
extern	int		_io_mpu401_choices[];
extern	int		_io_joystick_choices[];

BYTE	bWrConfigFile( const char *_lpConfigFileName );
BYTE	bRdConfigFile( const char *_lpConfigFileName );

extern WORD     gwDevFuncNum;

extern BYTE     gbPCIBios;

void 	vSetConfigDefaults( void );
BYTE	bWrConfigFile( const char *_lpConfigFileName );
BYTE	bRdConfigFile( const char *_lpConfigFileName );
void	vConfigureSetup( void );
void    vSelectIOAudio( void );
void    vSelectIRQAudio( void );
void    vSelectIOMPU401( void );
void    vSelectIOJoystick( void );
