#define HSAMPLE_DIV_FIRST 18
#define HSAMPLE_DIV_LAST  35

/*****************************************************************************/
/* DSP Type Definitions                                                      */
/*****************************************************************************/
/* Transfer Types */

/*
#define	_BIT_MONO			0x00
#define	_BIT_STEREO			0x01

#define	ES_BIT_8BIT			0x00
#define ES_BIT_16BIT        0x02
           
#define	ES_BIT_UNSIGNED		0x00
#define ES_BIT_SIGNED       0x04
*/

/* Transfer Modes /*
#define	_ES_BIT_NON_AI			0
#define	_ES_BIT_AI       		1

#define	_ES_BIT_SINGLE			0
#define	_ES_BIT_DEMAND2			1
#define	_ES_BIT_DEMAND4			2
#define	_ES_BIT_DEMAND8			3
*/

#define	_ES_PLAYBACK        0
#define	_ES_RECORD          1


/* Transfer Types */
#define	_ES_MONO		0x40
#define	_ES_STEREO		0x08

#define	_ES_8BIT		0x00
#define	_ES_16BIT		0x04

#define	_ES_SIGNED		0x20
#define	_ES_UNSIGNED	0x00

/* Transfer Modes */
#define	_ES_NON_AI		0x00
#define	_ES_AI			0x10

#define	_ES_SINGLE		0x00
#define	_ES_DEMAND2		0x40
#define	_ES_DEMAND4		0x80
#define	_ES_DEMAND8		0xC0


/*****************************************************************************/
/*  I/O Port Declarations                                                    */
/*****************************************************************************/
#define	_ES_DSP_RESET			( gwIOAudio + 0x06 )

#define	_ES_DSP_DATA_IN			( gwIOAudio + 0x0A )
#define	_ES_DSP_DATA_OUT		( gwIOAudio + 0x0C )

#define	_ES_DSP_RW_STATUS   	( gwIOAudio + 0x0C )

#define	_ES_DSP_RD_STATUS   	( gwIOAudio + 0x0C)
#define	_ES_DSP_RD_MSK      	0x40
#define	_ES_DSP_RD_RDY      	0x40

#define	_ES_DSP_WR_STATUS   	( gwIOAudio + 0x0C )
#define	_ES_DSP_WR_MSK			0x80
#define	_ES_DSP_WR_RDY      	0x00

#define	_ES_DSP_FIFO_DATA		( gwIOAudio + 0x0F )

#define	_ES_DSP_FIFO_STATUS		( gwIOAudio + 0x0C )
#define	 _ES_DSP_FIFO_FULL		0x20
#define	 _ES_DSP_FIFO_EMPTY		0x10
#define	 _ES_DSP_FIFO_HE		0x08
#define	 _ES_DSP_FIFO_HE_INT	0x02


/*****************************************************************************/
/*  DSP Register Bitmask & Status Definitions                                */
/*****************************************************************************/
#define	_ES_DSP_RESET_ON		0x01				/* Enable DSP Reset */
#define	_ES_DSP_RESET_OFF		0x00				/* Disable DSP Reset */

#define	_ES_DSP_RESET_FIFO_ON	0x03				/* Enable FIFO Reset */
#define	_ES_DSP_RESET_FIFO_OFF	0x00				/* Disable FIFO Reset */

#define	_ES_DSP_RESET_OK		0xAA				/* DSP Reset Response */

/*****************************************************************************/
/*  DSP Error Code Definitions                                               */
/*****************************************************************************/
#define	_ES_DSP_OK				0x00				/* No Error */
#define	_ES_DSP_ERROR			-1					/* General DSP Error */
#define	_ES_DSP_TIMEOUT_ERROR	-2					/* General DSP Timeout Error */
#define	_ES_DSP_RESET_ERROR		-3					/* DSP Reset Timeout Error */
#define	_ES_DSP_RD_ERROR		-4					/* DSP Read Timeout Error */
#define	_ES_DSP_WR_ERROR		-5					/* DSP Write Timeout Error */

/*****************************************************************************/
/*  DSP Commands                                                             */
/*****************************************************************************/
#define	_ES_DSP_XMODE_ON		0xC6				/* Enable Extended Mode / Disable Compatibility Mode */
#define	_ES_DSP_XMODE_OFF		0xC5				/* Enable Compatibility Mode / Disable Extended Mode */

/*****************************************************************************/
/*  DSP Timeout Definitions                                                  */
/*****************************************************************************/
#define	_ES_DSP_RESET_TIMEOUT	5000					/* DSP Reset Timeout Value */
#define	_ES_DSP_RD_TIMEOUT  	5000					/* DSP Read Timeout Value */
#define	_ES_DSP_WR_TIMEOUT  	5000					/* DSP Write Timeout Value */

/*****************************************************************************/
/*  DSP Extended Register:	0xA1 - Sample Rate Divisor                       */
/*****************************************************************************/
#define	_ES_DSP_XREG_SMPLRATE	0xA1                /* Sample Rate Divisor */

/*****************************************************************************/
/*  DSP Extended Register:	0xA2 - Filter Clock Divisor                      */
/*****************************************************************************/
#define	_ES_DSP_XREG_FCLOCK		0xA2				/* Filter Clock Divider */

/*****************************************************************************/
/*  DSP Extended Register:	0xA4 - DMA Transfer Counter Reload Register      */
/*****************************************************************************/
#define	_ES_DSP_XREG_DMA_CNTLO	0xA4				/* DMA Transfer Counter Reload -- Low Byte */
#define	_ES_DSP_XREG_DMA_CNTHI	0xA5				/* DMA Transfer Counter Reload -- High Byte */

/*****************************************************************************/
/*  DSP Extended Register:	0xA8 -                                           */
/*****************************************************************************/
#define	_ES_DSP_XREG_STEREO		0xA8				/* Stereo Mode */
#define	 _ES_DSP_REC_MON_ON		0x04				/* */
#define	 _ES_DSP_REC_MON_OFF	0x00				/* */

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
#define	_ES_DSP_
/*****************************************************************************/
/*  DSP Extended Register 0xB1 - IRQ Control Register                        */
/*****************************************************************************/
#define	_ES_DSP_XREG_IRQ_CNTL	(0xB1)				/* DSP XREG: IRQ Control Register */
#define	 _ES_DSP_IRQ_PROC		0x80				/* Processor IRQ */
#define	 _ES_DSP_IRQ_COVF		0x40				/* Enable IRQ on DMA Controller Overflow */
#define	 _ES_DSP_IRQ_FIFO		0x20				/* IRQ on FIFO Half Empty Change */
#define	 _ES_DSP_IRQ_GP			0x10				/* General IRQx Tri-State Enable */
#define	 _ES_DSP_IRQD_REG		0x0C				/* Enable IRQ D */
#define	 _ES_DSP_IRQC_REG		0x08				/* Enable IRQ C */
#define	 _ES_DSP_IRQB_REG		0x04				/* Enable IRQ B */
#define	 _ES_DSP_IRQA_REG		0x00				/* Enable IRQ A */

#define	 _ES_DSP_IRQD_PIN		0x03				/* Enable IRQ D */
#define	 _ES_DSP_IRQC_PIN		0x02				/* Enable IRQ C */
#define	 _ES_DSP_IRQB_PIN		0x01				/* Enable IRQ B */
#define	 _ES_DSP_IRQA_PIN		0x00				/* Enable IRQ A */

/*****************************************************************************/
/*  DSP Extended Register:0xB2 - DRQ Control Register                        */
/*****************************************************************************/
#define	_ES_DSP_XREG_DRQ_CNTL	0xB2				/* DSP XREG: DRQ Control Register */
#define	 _ES_DSP_DRQ_PROC		0x80				/* Processor DRQ */
#define	 _ES_DSP_DRQ_XDMA		0x40				/* Enable DRQ for Extended DMA */
#define	 _ES_DSP_DRQ_CDMA		0x20				/* Enable DRQ for Compatibility Mode */
#define	 _ES_DSP_DRQ_PDIN		0x10				/* Enable pulldown Inactive DRQ */

#define	 _ES_DSP_DRQD_REG		0x0C				/* Enable DRQ D */
#define	 _ES_DSP_DRQC_REG		0x08				/* Enable DRQ C */
#define	 _ES_DSP_DRQB_REG		0x04				/* Enable DRQ B */
#define	 _ES_DSP_DRQA_REG		0x00				/* Enable DRQ A */

#define	 _ES_DSP_DRQD_PIN		0x03				/* Enable DRQ D */
#define	 _ES_DSP_DRQC_PIN		0x02				/* Enable DRQ C */
#define	 _ES_DSP_DRQB_PIN		0x01				/* Enable DRQ B */
#define	 _ES_DSP_DRQA_PIN		0x00				/* Enable DRQ A */

/*****************************************************************************/
/*  DSP Extended Register                                                    */
/*****************************************************************************/
#define	_ES_DSP_XREG_INP_VOL	0xB4				/* Input Volume Control Register */

/*****************************************************************************/
/*  DSP Extended Register:	0xB8 -                                           */
/*****************************************************************************/
#define _ES_DSP_XREG_DIRECTION	0xB8				/*  */
#define  _ES_DSP_NON_AI			0x00				/* Non-AutoInitialize Transfer */
#define  _ES_DSP_AI				0x04                /* AutoInitialize Transfers */

/*****************************************************************************/
/*  DSP Extended Register:  0xB9 -                                           */
/*****************************************************************************/
#define _ES_DSP_XREG_DEMAND		0xB9				/* Demand Mode  */
#define  _ES_DSP_SINGLE			0x00				/* Single Transfer DMA */
#define  _ES_DSP_DEMAND2		0x01				/* Demand Transfer, 2 bytes per DMA request */
#define  _ES_DSP_DEMAND4		0x02				/* Demand Transfer, 4 bytes per DMA request */


/*****************************************************************************/
/*  Function Declarations                                                    */
/*****************************************************************************/
void	vWakeUpChip( void );
void	vSendReadKeySequence( void );

BYTE	bGetDSPStatus( void );
BYTE	bGetDSPRdStatus( void );
BYTE	bGetDSPWrStatus( void );

int		iWrDSP( BYTE _bDSPData );
int		iRdDSP( void );

int		iRdXReg( BYTE _bXReg );
int		iWrXReg( BYTE _bXReg, BYTE _bXData );

int		iSetXRegBit( BYTE _bXReg, BYTE _bBit );
int		iMskXRegBit( BYTE _bXReg, BYTE _bBit );
int		iTstXRegBit( BYTE _bXReg, BYTE _bBit );

int		iResetDSP( void );

BYTE	bRdFIFO( void );
BYTE	bWrFIFO( BYTE _bData );
int		iResetFIFO( void );

int		iEnableExtendedMode( void );
int		iDisableExtendedMode( void );

int		iEnableRecordMonitor( void );
int		iDisableRecordMonitor( void );

int		iGetDACStatus( void );
int		iEnableDAC( void );
int		iDisableDAC( void );

int     iSetDSP8BitTransfer( BYTE _bDSPChannel );
int     iSetDSP16BitTransfer( BYTE _bDSPChannel );

int     iSetDSP8BitsPerSample( BYTE _bDSPChannel );
int     iSetDSP16BitsPerSample( BYTE _bDSPChannel );

int     iSetDSPAutoInitMode( BYTE _bDSPChannel );
int     iSetDSPNonAutoInitMode( BYTE _bDSPChannel );

int		iEnableFullDuplex( void );
int		iDisableFullDuplex( void );

int		iEnableSecondaryDSPChannel( void );
int		iDisableSecondaryDSPChanne( void );

int     iClearIRQEOutput( void );

int     iEnableIRQEOutput( void );
int     iDisableIRQEOutput( void );

int		iSetDSPSampleRate( BYTE _bDSPChannel, WORD _wSampleRate );
int		iSetDSPFilterClock( BYTE _bDSPChannel, WORD _wFilterClock );

int		iSetDSPIRQControl( BYTE _bDSPChannel, BYTE _bIRQFlags );
int		iSetDSPDRQControl( BYTE _bDSPChannel, BYTE _bDRQFlags );

int		iSetDSPTransferSize( BYTE _bDSPChannel, WORD _wBufferSize );

int		iSetDSPTransferMode( BYTE _bDSPChannel, BYTE _bModeFlags );
int		iSetDSPTransferType( BYTE _bDSPChannel, BYTE _bTypeFlags );

int		iConfigureDAC( BYTE _bDSPChannel, BYTE _bTypeFlags );
int		iConfigureADC( BYTE _bDSPChannel, BYTE _bTypeFlags );

int		iStartDSPTransfer( BYTE _bDSPChannel );
int		iStopDSPTransfer( BYTE _bDSPChannel );
int		iPauseDSPTransfer( BYTE _bDSPChannel );
int		iResumeDSPTransfer( BYTE _bDSPChannel );


int     iSetDSPSampleRate( BYTE _bDSPChannel, WORD _wSampleRate );
int     iSetDSPFilterClock( BYTE _bDSPChannel, WORD _wFilterClock );
int     iSetDSPIRQControl( BYTE _bDSPChannel, BYTE _bIRQFlags );
int     iSetDSPDRQControl( BYTE _bDSPChannel, BYTE _bDRQFlags );
int     iSetDSPTransferSize( BYTE _bDSPChannel, WORD _wBufferSize );
int     iSetDSPUnsigned( BYTE _bDSPChannel );
int     iSetDSPSigned( BYTE _bDSPChannel );
int     iSetDSP8BitTransfer( BYTE _bDSPChannel );
int     iSetDSP16BitTransfer( BYTE _bDSPChannel );
int     iSetDSP8BitsPerSample( BYTE _bDSPChannel );
int     iSetDSP16BitsPerSample( BYTE _bDSPChannel );
int     iSetDSPAutoInitMode( BYTE _bDSPChannel );
int     iSetDSPNonAutoInitMode( BYTE _bDSPChannel );
int     iSetDSPSingleMode( BYTE _bDSPChannel );
int     iSetDSPDemandMode( BYTE _bDSPChannel );
int     iSetDSPMono( BYTE _bDSPChannel );
int     iSetDSPStereo( BYTE _bDSPChannel );
int     iStartDSPTransfer( BYTE _bDSPChannel );
int     iStopDSPTransfer( BYTE _bDSPChannel );
int     iPauseDSPTransfer( BYTE _bDSPChannel );
int     iResumeDSPTransfer( BYTE _bDSPChannel );

int     iSetDACTransfer( BYTE _bDSPChannel, LPBYTE _lpBufferPtr, WORD _wBufferSize, WORD _wSampleRate, BYTE _bDSPModeFlags, BYTE _bDSPTypeFlags );
int     iSetADCTransfer( LPBYTE _lpBufferPtr, WORD _wBufferSize, WORD _wSampleRate, BYTE _bDSPModeFlags, BYTE _bDSPTypeFlags );

