#include	<stdio.h>
#include	<stdlib.h>
#include	<conio.h>

#include	"stdtype.h"
#include	"config.h"
#include    "mixer.h"

BYTE	gbMixerTable[ 0xFF ];

/*****************************************************************************/
/* bWrMRegSelect - Write Mixer Register Address                              */
/*****************************************************************************/
BYTE	bWrMRegSelect( BYTE _bMixerReg )
	{
	return( (BYTE)outp( _ES_MIX_REG_SELECT, _bMixerReg ) );
	}
	
/*****************************************************************************/
/* bRdMRegSelect - Read Mixer Register Address                               */
/*****************************************************************************/
BYTE	bRdMRegSelect( void )
	{
	return( (BYTE)inp( _ES_MIX_REG_SELECT ) );
	}

/*****************************************************************************/
/* bWrMRegData - Write Data to Mixer Register                                */
/*****************************************************************************/
BYTE	bWrMRegData( BYTE _bMixerData  )
	{
	return( (BYTE)outp( _ES_MIX_REG_DATA, _bMixerData ) );
	}
	
/*****************************************************************************/
/* bRdMRegData - Read Data from Mixer Register                               */
/*****************************************************************************/
BYTE	bRdMRegData( void )
	{
	return( (BYTE)inp( _ES_MIX_REG_DATA ) );
	}
	
/*****************************************************************************/
/* bWrMReg - Write Mixer Register                                            */
/*****************************************************************************/
BYTE	bWrMReg( BYTE _bMixerReg, BYTE _bMixerData )
    {
    bWrMRegSelect( _bMixerReg );
    return( bWrMRegData( _bMixerData ) );
    }

/*****************************************************************************/
/* bRdMReg - Read Mixer Register                                             */
/*****************************************************************************/
BYTE	bRdMReg( BYTE _bMixerReg )
    {
    bWrMRegSelect( _bMixerReg );
    return( bRdMRegData() );
    }

/*****************************************************************************/
/* bSetMRegBit - Set Single Bit in Mixer Register                            */
/*****************************************************************************/
BYTE	bSetMRegBit( BYTE _bMixerReg, BYTE _bBit )
    {
	BYTE	bRetVal = bWrMReg( _bMixerReg, (BYTE)BSETBIT( bRdMReg( _bMixerReg ), _bBit ) );

    return( bRetVal );
    }

/*****************************************************************************/
/* bMskMRegBit - Clear Single Bit in Mixer Register                          */
/*****************************************************************************/
BYTE	bMskMRegBit( BYTE _bMixerReg, BYTE _bBit )
    {
	BYTE	bRetVal = bWrMReg( _bMixerReg, BMSKBIT( bRdMReg( _bMixerReg ), _bBit ) );

    return( bRetVal );
    }

/*****************************************************************************/
/* bTstMRegBit - Test Single Bit State in Mixer Register                     */
/*****************************************************************************/
BYTE	bTstMRegBit( BYTE _bMixerReg, BYTE _bBit )
    {
	BYTE	bRetVal = BTSTBIT( bRdMReg( _bMixerReg ), _bBit );

    return( bRetVal );
    }

/*****************************************************************************/
/* vResetMixer - Reset Mixer Registers                                       */
/*****************************************************************************/
void	vResetMixer( void )
	{
	bWrMReg( 0x00, 0x00 );
	}
		
/*****************************************************************************/
/* vSaveMixer - Save all mixer settings                                      */
/*****************************************************************************/
void	vSaveMixer( void )
	{
	BYTE	bIndex;
	
	for( bIndex=1; bIndex < 0xFF; bIndex++ )
		{
		gbMixerTable[ bIndex ] = bRdMReg( bIndex );
		}
	}

/*****************************************************************************/
/* vSaveMixer - Save all mixer settings                                      */
/*****************************************************************************/
void	vRestoreMixer( void )
	{
	BYTE	bIndex;
	
	for( bIndex=1; bIndex < 0xFF; bIndex++ )
		{
		bWrMReg( bIndex, gbMixerTable[ bIndex ] );
		}
	}

