/*****************************************************************************/
/*  DSP Extended Register:	0xA8 -                                           */
/*****************************************************************************/
#define	_ES_MIX_REG_SELECT	(gwIOAudio + 4)
#define	_ES_MIX_REG_DATA	(gwIOAudio + 5)

/*****************************************************************************/
/*  DSP Mixer Register:	Alt DAC Sample Rate Divisor                          */
/*****************************************************************************/
#define	_ES_DSP_MREG_SMPLRATE	0x70                /* Alt DAC Sample Rate Divisor */

/*****************************************************************************/
/*  DSP Mixer Register:	Alt DAC Filter Clock Divisor                         */
/*****************************************************************************/
#define	_ES_DSP_MREG_FCLOCK		0x72				/* Alt DAC Filter Clock Divider */

/*****************************************************************************/
/*  DSP Mixer Register:	Alt DAC Control                                      */
/*****************************************************************************/
#define	_ES_DSP_MREG_ADAC_CTRL1	    0x78									   /* Alt DAC Control 1 */

#define  _ES_DSP_MREG_ADAC1_DEMAND8  0xC0
#define  _ES_DSP_MREG_ADAC1_DEMAND4  0x80
#define  _ES_DSP_MREG_ADAC1_DEMAND2  0x40
#define  _ES_DSP_MREG_ADAC1_SINGLE   0x00

#define	 _ES_DSP_ADAC1_16BIT_XFER	 0x20									   /* DMA Transfer Size (0=8Bit/1=16Bit) */
#define	 _ES_DSP_ADAC1_8BIT_XFER	 0x00									   /* DMA Transfer Size (0=8Bit/1=16Bit) */

#define	 _ES_DSP_ADAC1_AI			 0x10									   /* AutoInitialize */
#define	 _ES_DSP_ADAC1_NON_AI		 0x00									   /* AutoInitialize */

#define	 _ES_DSP_ADAC1_RESUME		 0x08									   /* Suspend Request Completed Flag */
#define	 _ES_DSP_ADAC1_SUSPEND		 0x04									   /* Suspend Alternate DMA Request/Hold DMA */

#define	 _ES_DSP_ADAC1_ENABLE_DMA2	 0x02									   /* Enable AutoMode */
#define	 _ES_DSP_ADAC1_ENABLE_FIFO2  0x01									   /* Enable FullDuplex */


#define	 _ES_DSP_ADAC1_DEMAND1	0x07				/* Demand Mode Control 1 */
#define	 _ES_DSP_ADAC1_DEMAND0	0x06				/* Demand Mode Control 2 */
#define	 _ES_DSP_ADAC1_XFERSIZE	0x05				/* DMA Transfer Size (0=8Bit/1=16Bit) */
#define	 _ES_DSP_ADAC1_AUTOINIT	0x04				/* AutoInitialize */
#define	 _ES_DSP_ADAC1_DMAFIFO	0x01				/* Enable DMA transfer into FIFO */
#define	 _ES_DSP_ADAC1_FIFO_DA	0x00				/* Enable FIFO to D/A */


/*****************************************************************************/
/*  DSP Mixer Register:	Alt DAC Control                                      */
/*****************************************************************************/
#define	_ES_DSP_MREG_ADAC_CTRL2	 	0x7A									   /* Alt DAC Control 2 */
#define  _ES_DSP_ADAC2_IRQE_ACTIVE 	 0x80									   /* Second DMA channel Interrupt Request Latch */
#define	 _ES_DSP_ADAC2_ENABLE_IRQE 	 0x40									   /* Second DMA channel Interrupt Request Enable */
#define	 _ES_DSP_ADAC2_ENABLE_DRQD 	 0x20									   /* Reserved */

#define	 _ES_DSP_ADAC2_RECORD_MIXER	 0x08
#define	 _ES_DSP_ADAC2_RECORD_FMDAC	 0x10									   /* Reserved */
#define	 _ES_DSP_ADAC2_RECORD_ALTDAC 0x18									   /* Reserved */

#define	 _ES_DSP_ADAC2_SIGNED    	 0x04									   /* Data Type 0=Unsigned/1-Signed */
#define	 _ES_DSP_ADAC2_STEREO    	 0x02									   /* Stereo Flag (0=Mono/1=Stereo ) */

#define	 _ES_DSP_ADAC2_16BIT		0x01									   /* BitsPerSample (0=8Bit/1=16Bit) */
#define	 _ES_DSP_ADAC2_8BIT		 	0x00									   /* BitsPerSample (0=8Bit/1=16Bit) */


#define  _ES_DSP_ADAC2_FLG_IRQ		0x07               /* Second DMA channel Interrupt Request Latch */
#define	 _ES_DSP_ADAC2_FLG_IRQ_LTC	0x06               /* Second DMA channel Interrupt Request Enable */
#define	 _ES_DSP_ADAC2_RESERVED1	0x05               /* Reserved */
#define	 _ES_DSP_ADAC2_RESERVED2	0x04               /* Reserved */
#define	 _ES_DSP_ADAC2_RESERVED3	0x03               /* Reserved */
#define	 _ES_DSP_ADAC2_FLG_SIGN		0x02               /* Data Type 0=Unsigned/1-Signed */
#define	 _ES_DSP_ADAC2_FLG_STEREO	0x01               /* Stereo Flag (0=Mono/1=Stereo ) */
#define	 _ES_DSP_ADAC2_FLG_WORDSIZE	0x00               /* BitsPerSample (0=8Bit/1=16Bit) */

/*****************************************************************************/
/*  DSP Mxier Register:                                                      */
/*****************************************************************************/
#define	_ES_DSP_MREG_DMA2_CNTLO	0x74										   /* Alt DMA Transfer Counter Reload -- Low Byte */
#define	_ES_DSP_MREG_DMA2_CNTHI	0x76										   /* Alt DMA Transfer Counter Reload -- High Byte */

#define	_MREG_PM_ALTDAC_VOLUME			0x7C

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
#define	_MREG_PM_MASTER_VOLUME		0x32

#define	_MREG_PM_MASTERL_VOLUME		0x60
#define	_MREG_PM_MASTERR_VOLUME		0x62

#define	_MREG_PM_WAVE_VOLUME		0x14
#define	_MREG_PM_ALTDAC_VOLUME		0x7C
#define	_MREG_PM_MIC_VOLUME			0x1A
#define	_MREG_PM_FMSYNTH_VOLUME		0x36
#define	_MREG_PM_LINEIN_VOLUME		0x3E
#define	_MREG_PM_CDLINEIN_VOLUME	0x38
#define	_MREG_PM_AUXB_VOLUME		0x3A
#define	_MREG_PM_MONOIN_VOLUME		0x6D
#define	_MREG_PM_PCSPK_VOLUME		0x3C

#define	_MREG_PM_MONOOUT_SOURCE		0x7D

#define	_MREG_RM_SOURCE				0x1C

#define	_MREG_RM_FMSYNTH_VOLUME		0x6B
#define	_MREG_RM_AUXB_VOLUME		0x6C
#define	_MREG_RM_MIC_VOLUME			0x68
#define	_MREG_RM_CDLINEIN_VOLUME	0x6A
#define	_MREG_RM_LINEIN_VOLUME		0x6E
#define	_MREG_RM_MONOIN_VOLUME		0x6F
#define	_MREG_RM_ALTDAC_VOLUME		0x6A

#define	_XREG_RM_WAVEIN_VOLUME		0xB4

#define	_SRC_MIC		0
#define	_SRC_SPLIT		1
#define	_SRC_CD			2
#define	_SRC_AOUT		3
#define	_SRC_MIC2		4
#define	_SRC_MIXER		5
#define	_SRC_LINEIN		6

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
BYTE	bWrMRegSelect( BYTE bMixerReg );
BYTE	bRdMRegSelect( void );

BYTE	bWrMRegData( BYTE bMixerData );
BYTE	bRdMRegData( void );

BYTE	bRdMReg( BYTE bMixerReg );
BYTE	bWrMReg( BYTE bMixerReg, BYTE bMixerData );

BYTE	bSetMRegBit( BYTE bMixerReg, BYTE bBit );
BYTE	bMskMRegBit( BYTE bMixerReg, BYTE bBit );
BYTE	bTstMRegBit( BYTE bMixerReg, BYTE bBit );

void	vResetMixer( void );

/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
#define _ES_LMASTER_VOLUME  0x37
#define _ES_RMASTER_VOLUME  0x37

#define _ES_MASTER_VOLUME   0x99
#define	_ES_VOICE_VOLUME	0x99
#define	_ES_MPU401_VOLUME	0x99
#define	_ES_LINE_IN_VOLUME	0x99
#define	_ES_CD_LINE_VOLUME	0x99
#define	_ES_SYNTH_VOLUME	0x99
#define	_ES_ALTDAC_VOLUME	0x99
#define	_ES_MIC_VOLUME		0x99

#define	_ES_INPUT_VOLUME	0x55


BYTE	bSetWaveVolume( BYTE _bDSPChannel, BYTE _bVolume );	/* defined in ESxxxx.C */
BYTE	bGetWaveVolume( BYTE _bDSPChannel );				/* defined in ESxxxx.C */
void	vSetRecordSource( BYTE _bSource );					/* defined in ESxxxx.C */

void	vSaveMixer( void );
void	vRestoreMixer( void );
