#include	<stdio.h>
#include	<stdlib.h>
#include	<dos.h>

#include    "stdtype.h"
#include	"io32bit.h"

#include    "pciio.h"

#define DEVICE_ENABLE		0x80000000

#define	PCI_CONFIG_INDEX    (WORD)0x0CF8
#define PCI_CONFIG_DATA     (WORD)0x0CFC

DWORD   gdwPCISlot;             /* Maestro PCI 32-Bit Slot Number */
BYTE    gbPCIBios = TRUE;
WORD    gwDevFuncNum;

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vWrPCIRegIndex( DWORD _dwPCIRegIndex )
	{
	outpd( PCI_CONFIG_INDEX, _dwPCIRegIndex );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
DWORD	dwRdPCIRegIndex( void )
	{
	return( (DWORD)inpd( PCI_CONFIG_INDEX ) );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vWrPCIRegData( DWORD _dwPCIRegData )
	{
	outpd( PCI_CONFIG_DATA, _dwPCIRegData );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
DWORD	dwRdPCIRegData( void )
	{
	return( (DWORD)inpd( PCI_CONFIG_DATA ) );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vWrPCIReg( DWORD _dwPCIRegIndex, DWORD _dwPCIRegData )
	{
    if( gbPCIBios )
        {

        vWrConfWord( gwDevFuncNum, (WORD)_dwPCIRegIndex, LOWORD( _dwPCIRegData ) );
        vWrConfWord( gwDevFuncNum, (WORD)_dwPCIRegIndex + 2, HIWORD( _dwPCIRegData ) );

//        vWrConfDWord( gwDevFuncNum, (WORD)_dwPCIRegIndex, _dwPCIRegData );
        }
    else
        {
        vWrPCIRegIndex( gdwPCISlot | _dwPCIRegIndex );
        vWrPCIRegData( _dwPCIRegData );
        }
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
DWORD	dwRdPCIReg( DWORD _dwPCIRegIndex )
	{
    if( gbPCIBios )
        {
//        return( dwRdConfDWord( gwDevFuncNum, (WORD)_dwPCIRegIndex ) );

        return( MAKELONG( wRdConfWord( gwDevFuncNum, (WORD)_dwPCIRegIndex ), wRdConfWord( gwDevFuncNum, (WORD)( _dwPCIRegIndex + 2 ) ) ) );

        }
    else
        {
        vWrPCIRegIndex( gdwPCISlot | _dwPCIRegIndex );
        return( (DWORD)dwRdPCIRegData() );
        }
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vSetPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit )
    {
    vWrPCIReg( _dwPCIRegIndex, DWSETBIT( dwRdPCIReg( _dwPCIRegIndex ), _bPCIRegBit ) );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vMskPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit )
    {
    vWrPCIReg( _dwPCIRegIndex, DWMSKBIT( dwRdPCIReg( _dwPCIRegIndex ), _bPCIRegBit ) );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE    bTstPCIRegBit( DWORD _dwPCIRegIndex, BYTE _bPCIRegBit )
    {
    return( (BYTE)( DWTSTBIT( dwRdPCIReg( _dwPCIRegIndex ), _bPCIRegBit ) ) );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int iGetPCIBios( void )
    {
    WORD    wRetVal = 0;

	union REGS x86Regs;
	
    x86Regs.x.ax = 0xB101;

    int86( 0x1A, &x86Regs, &x86Regs );

	if( x86Regs.h.ah == 0 )
		{
        wRetVal = (WORD)x86Regs.x.ax;
		}
		
    return( wRetVal );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	iFindPCIDevice( WORD _wDeviceID, WORD _wVendorID )
	{
    WORD	wDevFuncNum = 0xFFFF;

	union REGS x86Regs;
	
    x86Regs.x.ax = 0xB102;
    x86Regs.x.cx = _wDeviceID;
    x86Regs.x.dx = _wVendorID;
    x86Regs.x.si = 0x0000;
    
    int86( 0x1A, &x86Regs, &x86Regs );

	if( x86Regs.h.ah == 0 )
		{
		wDevFuncNum = (WORD)x86Regs.x.bx;
		}
		
	return( wDevFuncNum );
	}


/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int iSetPCIInterruptRouting( WORD _wDevFuncNum, BYTE _bInterruptPin, BYTE _bIRQLine )
    {
    union REGS x86Regs;
    struct SREGS x86SRegs;

    x86Regs.x.ax = 0xB10F;
    x86Regs.x.bx = _wDevFuncNum;
    x86Regs.h.cl = _bInterruptPin;
    x86Regs.h.ch = _bIRQLine;
    x86SRegs.ds  = 0xF000;

    int86x( 0x1A, &x86Regs, &x86Regs, &x86SRegs );

    x86Regs.h.al = x86Regs.h.ah;

    return( x86Regs.x.ax );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int iGetPCIInterruptRouting( PROUTINGHEADER _pRoutingTableHeader )
    {
    union REGS x86Regs;
    struct SREGS x86SRegs;

    x86Regs.x.ax = 0xB10E;
    x86Regs.x.bx = 0x0000;
    x86SRegs.ds  = 0xF000;

    x86SRegs.es  = _FP_SEG( _pRoutingTableHeader );
    x86Regs.x.di = _FP_OFF( _pRoutingTableHeader );

    int86x( 0x1A, &x86Regs, &x86Regs, &x86SRegs );

    x86Regs.h.al = x86Regs.h.ah;

    return( x86Regs.x.bx );
    }

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
DWORD   dwRdPCISlot( BYTE _bSlot )
    {
    union REGS x86Regs;
    struct SREGS x86SRegs;

    x86Regs.x.ax = 0xD804;
    x86Regs.h.cl = _bSlot;

    int86x( 0x1A, &x86Regs, &x86Regs, &x86SRegs );

    x86Regs.h.al = x86Regs.h.ah;

    return( (DWORD)( MAKEDWORD( x86Regs.x.di, x86Regs.x.si ) ) );
    }

