#include    <stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<conio.h>
#include	<dos.h>
#include	<io.h>
#include	<fcntl.h>
#include	<sys\stat.h>

#include	"stdtype.h"
#include    "config.h"
#include    "dsp.h"
#include    "mixer.h"
#include    "delay.h"
#include    "mem.h"
#include    "screenio.h"
#include    "display.h"

#include	"ic8237.h"
#include	"ic8259.h"

#include    "play.h"

BYTE    gbRecordChannel = _ES_CHANNEL0;     /* can only record on primary channel */


LPBYTE  glpRecordBuffer;

WORD    gwRecordDskSeg;

WORD    gwRecordDacPos;

WORD    wCurrentRecDmaBuffer,
		wCurrentRecDskBuffer,
        wRecDmaBufferIndex,
        wRecDskBufferIndex;


/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void _interrupt _far aiAudioISR( void )
	{
	
#ifdef	_DEBUG
	BYTE	index;

	LPBYTE lpTmpPtr = ( (LPBYTE) 0xB8000000L );
		
	for( index=4; index > 0; index-- )
		{
		if( ( lpTmpPtr[index<<1] < 0x30 ) || ( lpTmpPtr[index<<1] > 0x39 ) )
			{
			lpTmpPtr[index<<1] = 0x30;
			}
		else
			{
			if( lpTmpPtr[index<<1] == 0x39 )
				{
				lpTmpPtr[index<<1] = 0x30;
				}
			else 
				{
				++lpTmpPtr[index<<1];
				break;
				}
			}
		}
#endif

    bIRQTestFlag[0] = TRUE;

    gwRecordDacPos = (WORD)inpw( gwIODMA[ gbRecordChannel ] ) - gwRecordDskSeg;

	inp( gwIOAudio + 0x0E );

    outp( gwIOAudio + 0x04, 0x7A );

    outp( gwIOAudio + 0x05, BMSKBIT( inp( gwIOAudio + 0x05 ), 7 ) );

 /* Send Non-Specific EOI to controller #1 */
	outp( 0x20, 0x20 );

 /* Send Non-Specific EOI to controller #2 */
	outp( 0xA0, 0x20 );


	_enable(  );
	}

/*****************************************************************************/
/* iSetADCTransfer - Setup DSP Transfer for ADC Input (Record)               */
/*                                                                           */
/*****************************************************************************/
int     iSetADCTransfer( LPBYTE _lpBufferPtr, WORD _wBufferSize, WORD _wSampleRate, BYTE _bDSPModeFlags, BYTE _bDSPTypeFlags )
    {
    int     iRetVal = _ES_DSP_OK;

    vDisplayDebugMessage( "iSetADCTransfer = SampleRate:% 5u Buffer:%04X:%04X\n", _wSampleRate, _FP_SEG( _lpBufferPtr ), _FP_OFF( _lpBufferPtr ) );

    if( ( iRetVal = iConfigureADC( gbRecordChannel, _bDSPTypeFlags ) ) == _ES_DSP_OK )
        {
        if( ( iRetVal = iSetDSPTransferSize( gbRecordChannel, _wBufferSize ) ) == _ES_DSP_OK )
            {
            if( ( iRetVal = iSetDSPSampleRate( gbRecordChannel, _wSampleRate ) ) == _ES_DSP_OK )
                {
                if( ( iRetVal = iSetDSPFilterClock( gbRecordChannel, _wSampleRate ) ) == _ES_DSP_OK )
					{
                    if( ( iRetVal = iSetDSPTransferMode( gbRecordChannel, _bDSPModeFlags ) ) == _ES_DSP_OK )
						{
                        if( ( iRetVal = iSetDSPTransferType( gbRecordChannel, _bDSPTypeFlags ) ) == _ES_DSP_OK )
							{
                            switch ( gbRecordChannel )
								{
								case _ES_CHANNEL0:
									break;

								case _ES_CHANNEL1:
									break;

								default:
									iRetVal = _ES_DSP_ERROR;
									break;
								}
							}
						else
							{
							vDisplayDebugMessage( "Unable to set dsp transfer type\n" );
							}
						}
					else
						{
						vDisplayDebugMessage( "Unable to set dsp transfer mode\n" );
						}
					}
				else
					{
					vDisplayDebugMessage( "Unable to set filter clock\n" );
					}
				}
			else
				{
				vDisplayDebugMessage( "Unable to set dsp sample rate\n" );
				}
			}
		else
			{
			vDisplayDebugMessage( "Unable to set dsp transfer size\n" );
			}
		}
	else
		{
		vDisplayDebugMessage( "Unable to configure adc\n" );
		}

	return ( iRetVal );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vRecord( const char *_lpFileName, WORD _wSampleRate )
	{
    int     iRecordFileHandle;

    BYTE    bTimeoutFlag = FALSE;

    BYTE    bDspTypeFlags = _ES_8BIT | _ES_STEREO | _ES_UNSIGNED;
	BYTE    bDspModeFlags = _ES_AI | _ES_SINGLE;

	BYTE    bInKey;

    WORD    wRecordDskPos = 0,
            wChunkSize;

    DWORD   dwPhysAddr;

    WORD    wSampleBufferSize = DMABUFFERSIZE >> 1;

    BYTE    bPass = 0;

    if( bDspTypeFlags & _ES_16BIT  )
        {
        wSampleBufferSize >>= 1;
        }

    if( bDspTypeFlags & _ES_STEREO )
        {
        if( bDspTypeFlags & _ES_16BIT )
            {
            wSampleBufferSize >>= 1;
            }
        else
            {
            wSampleBufferSize >>= 1;
            }
        }

	iResetFIFO(  );
	iEnableExtendedMode(  );

	iSetXRegBit( 0xB1, 6 );
	iSetXRegBit( 0xB2, 6 );

    if ( ( iRecordFileHandle = _open( _lpFileName, _O_CREAT | _O_TRUNC | _O_RDWR | _O_BINARY, _S_IFREG | _S_IREAD | _S_IWRITE ) ) != -1 )
		{
        if ( lpAllocateDMABuffer( 1, DMABUFFERSIZE, &glpRecordBuffer ) != NULL )
			{
            dwPhysAddr = (DWORD) (DWORD)( _FP_SEG( glpRecordBuffer ) << 4 ) + (DWORD)(_FP_OFF( glpRecordBuffer ) );
            gwRecordDskSeg = LOWORD( dwPhysAddr );

            iSetADCTransfer( glpRecordBuffer, wSampleBufferSize, _wSampleRate, bDspModeFlags, bDspTypeFlags );
            vSetDMATransfer( gbRecordChannel, glpRecordBuffer, DMABUFFERSIZE, _DMA_WRITE | _DMA_AI | _DMA_SINGLE );

            iSetXRegBit( 0xB8, 3 );
            iSetXRegBit( 0xB8, 1 );

            bInKey = 0;

            vInstallISR( gbIRQAudio, aiAudioISR );

            iEnableDAC();

            iStartDSPTransfer( gbRecordChannel );

            vSetEventWait( _HALF_SECOND, &bTimeoutFlag );

            do
				{
				if ( bIRQTestFlag[0] == TRUE )
					{
					bIRQTestFlag[0] = FALSE;

                    if( bPass > 2 )
                        {
                        if( wRecordDskPos < gwRecordDacPos )
                            {
                            wChunkSize = gwRecordDacPos - wRecordDskPos;
                            write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], wChunkSize );
                            }

                        if( wRecordDskPos > gwRecordDacPos )
                            {
                            wChunkSize = DMABUFFERSIZE - wRecordDskPos;
                            write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], wChunkSize );

                            wRecordDskPos = 0;
                            write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], gwRecordDacPos );
                            }

                        if( wRecordDskPos == gwRecordDacPos )
                            {
                            }
                        }
                    else
                        {
                        ++bPass;
                        }


                    wRecordDskPos = gwRecordDacPos;
                    }

                if ( _kbhit() )
                    {
                    bInKey = (BYTE)getch();
                    }
                }
            while( ( bTimeoutFlag == FALSE ) && ( bInKey == 0x00 ) );

            vClearEventWait();

            iDisableDAC();

            iStopDSPTransfer( gbRecordChannel );

            vRemoveISR( gbIRQAudio );

            if( wRecordDskPos < gwRecordDacPos )
                {
                wChunkSize = gwRecordDacPos - wRecordDskPos;
                write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], wChunkSize );
                }

            if( wRecordDskPos > gwRecordDacPos )
                {
                wChunkSize = DMABUFFERSIZE - wRecordDskPos;
                write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], wChunkSize );

                wRecordDskPos = 0;
                write( iRecordFileHandle, &glpRecordBuffer[wRecordDskPos], gwRecordDacPos );
                }

            vFreeDMABuffer( glpRecordBuffer );
			}
		else
			{
            vDisplayDebugMessage( "Error allocating record buffer\n" );
			}
		close( iRecordFileHandle );
		}
	else
		{
		vDisplayDebugMessage( "Error creating record file\n" );
		}

    iResetFIFO();
    iEnableExtendedMode();
    }

