#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include    <stdarg.h>
#include    <dos.h>

#include	<graph.h>
#include	<conio.h>

#include	"stdtype.h"
#include	"config.h"
#include	"screenio.h"

BYTE	gbScreenText;

BYTE	gbScreenFGColor,
		gbScreenBGColor;
		
BYTE	gbCursorStartLine,
		gbCursorEndLine;
		
BYTE	gbCursorX,
		gbCursorY;

LPBYTE	glpScreen	=	((LPBYTE)0xB8000000L );
		
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetVideoMode( void )
	{
	union REGS inregs;
	
	inregs.h.ah = 0x0F;
	
	int86( 0x10, &inregs, &inregs );
	
	return( inregs.h.al );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	SetVideoMode( BYTE _bVideoMode )
	{
	union REGS inregs;
	
	inregs.h.ah = 0x00;
	inregs.h.al = _bVideoMode;
	
	int86( 0x10, &inregs, &inregs );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetVideoPage( BYTE _bVideoPage )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x05;
	x86Regs.h.al = _bVideoPage;
	
	int86( 0x10, &x86Regs, &x86Regs );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bGetVideoPage( void )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x0F;

	int86( 0x10, &x86Regs, &x86Regs );
	
	return( x86Regs.h.bh );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorStartLine( BYTE _bCursorStartLine )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x01;
	x86Regs.h.ch = _bCursorStartLine;
	x86Regs.h.cl = bGetCursorEndLine();
	
	int86( 0x10, &x86Regs, &x86Regs );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bGetCursorStartLine( void )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x03;
	x86Regs.h.bh = bGetVideoPage();
	
	int86( 0x10, &x86Regs, &x86Regs );
	
	return( x86Regs.h.ch );
	}
		
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorEndLine( BYTE _bCursorEndLine )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x01;
	x86Regs.h.ch = bGetCursorStartLine();
	x86Regs.h.cl = _bCursorEndLine;
	
	int86( 0x10, &x86Regs, &x86Regs );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
BYTE	bGetCursorEndLine( void )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x03;
	x86Regs.h.bh = bGetVideoPage();
	
	int86( 0x10, &x86Regs, &x86Regs );
	
	return( x86Regs.h.cl );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
WORD	wGetCursorSize( void )
	{
	return( (WORD)( ( bGetCursorStartLine() << 8 ) | bGetCursorEndLine() ) );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorSize( BYTE _bBeginScanLine, BYTE _bEndScanLine )
	{
    vSetCursorStartLine( _bBeginScanLine );
    vSetCursorEndLine( _bEndScanLine );
	}
	
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDisableCursor( void )
	{
	gbCursorStartLine = bGetCursorStartLine();
	gbCursorEndLine = bGetCursorEndLine();

	vSetCursorStartLine( 0x20 );
	vSetCursorEndLine( 0x20 );	
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vEnableCursor( void )
	{
	vSetCursorStartLine( gbCursorStartLine );
	vSetCursorEndLine( gbCursorEndLine );
	}                                 

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
WORD	wGetCursorPosition( void )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x03;
	inregs.h.bh = 0;

	int86( 0x10, &inregs, &inregs );
	
	return( (WORD) ( inregs.h.dl << 8 ) | inregs.h.dh );
*/
	return( (WORD)( gbCursorX << 8 ) | gbCursorY );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorPosition( int _bCursorX, int _bCursorY )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x02;
	inregs.h.bh = bGetVideoPage();
	inregs.h.dl = _bCursorX;
	inregs.h.dh = _bCursorY;

	int86( 0x10, &inregs, &inregs );
*/
	gbCursorX = (BYTE)_bCursorX;
	gbCursorY = (BYTE)_bCursorY;
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetCursorX( void )
	{
	return( (int) HIBYTE( wGetCursorPosition() ) );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorY( int _bCursorY )
	{
	vSetCursorPosition( bGetCursorX(), _bCursorY );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetCursorY( void )
	{
	return( (int) LOBYTE( wGetCursorPosition() ) );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetCursorX( int _bCursorX )
	{
	vSetCursorPosition( _bCursorX, bGetCursorY() );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetChar( void )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x08;
	inregs.h.bh = 0x00;
	
	int86( 0x10, &inregs, &inregs );
	
	return( inregs.h.al );
*/
	return( (int)( glpScreen[ ( gbCursorY << 7 ) + ( gbCursorY << 5 ) + ( gbCursorX << 1 ) ] ) ); 
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vPutChar( BYTE _bChar )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x0A;
	inregs.h.al = _bChar;
	inregs.h.bh = 0x00;
	inregs.x.cx = 1;
	
	int86( 0x10, &inregs, &inregs );
*/
	glpScreen[ ( gbCursorY << 7 ) + ( gbCursorY << 5 ) + ( gbCursorX << 1 ) ] = _bChar; 
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetColor( void )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x08;
	inregs.h.bh = 0x00;
	
	int86( 0x10, &inregs, &inregs );
	
	return( inregs.h.bh );
*/
	return( (int)( glpScreen[ ( gbCursorY << 7 ) + ( gbCursorY << 5 ) + ( gbCursorX << 1 ) + 1 ] ) ); 
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vPutColor( BYTE _bColor )
	{
/*
	union REGS inregs;
	
	inregs.h.ah = 0x09;
	inregs.h.al = bGetChar();
	inregs.h.bl = _bColor;
	inregs.h.bh = 0x00;
	inregs.x.cx = 1;
	
	int86( 0x10, &inregs, &inregs );
*/
	glpScreen[ ( gbCursorY << 7 ) + ( gbCursorY << 5 ) + ( gbCursorX << 1 ) + 1 ] = _bColor;
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
WORD	wGetMaxX( void )
	{
/*
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x0F;
	
	int86( 0x10, &x86Regs, &x86Regs );
	
	return( x86Regs.h.ah );
*/
	return( 79 );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
WORD	wGetMaxY( void )
	{
    return( 24 );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vClearScreen( void )
	{
	union REGS x86Regs;
	
	x86Regs.h.ah = 0x06;
	x86Regs.h.al = 0x00;
	
	x86Regs.h.bh = 0x07;
	
	x86Regs.h.cl = 0x00;
	x86Regs.h.ch = 0x00;
	
	x86Regs.h.dl = (BYTE)wGetMaxX();
	x86Regs.h.dh = (BYTE)wGetMaxY();
	
	int86( 0x10, &x86Regs, &x86Regs );
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetCharXY( int _bCursorX, int _bCursorY )
	{
	vSetCursorPosition( _bCursorX, _bCursorY );
	return( bGetChar() );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vPutCharXY( int _bCursorX, int _bCursorY, const char _bChar, int _bFGColor, int _bBGColor )
	{
	vSetCursorPosition( _bCursorX, _bCursorY );
	vPutColor( (BYTE)( ( _bFGColor & 0x0F ) | ( _bBGColor & 0x0F ) << 4 ) );
	vPutChar( _bChar );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vSetText( int _bFGColor, int _bBGColor )
	{
	gbScreenText = (BYTE)( ( _bBGColor << 4 ) | _bFGColor );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetText( void )
	{
	return( gbScreenText );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vPrintChar( char _bChar )
	{
	vPutColor( gbScreenText );
	vPutChar( _bChar );
	vSetCursorPosition( (int) (bGetCursorX() + 1), bGetCursorY() );
	}
	
/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void    vPrintString( const char * _lpString )
	{
	int	bIndex;

	for( bIndex=0; bIndex < (BYTE)strlen( _lpString ); ++bIndex )
		{
		vPrintChar( _lpString[ bIndex ] );
		}
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vPutColorXY( int _bCursorX, int _bCursorY, int _bFGColor, int _bBGColor )
	{
	vPrintCharXY( _bCursorX, _bCursorY, bGetCharXY( _bCursorX, _bCursorY ), _bFGColor, _bBGColor );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int	bGetColorXY( int _bCursorX, int _bCursorY )
	{
	vSetCursorPosition( _bCursorX, _bCursorY );
	return( bGetColor() );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vPrintCharXY( int _bCursorX, int _bCursorY, int _bChar, int _bFGColor, int _bBGColor )
	{
	vSetCursorPosition( _bCursorX, _bCursorY );
	vSetText( _bFGColor, _bBGColor );

	vPrintChar( (BYTE)_bChar );
	}
	
/*****************************************************************************/
/*                                                                           */
/*****************************************************************************/
void    vPrintStringXY( int _bCursorX, int _bCursorY, const char *_lpString, int _bFGColor, int _bBGColor )
    {
	vSetCursorPosition( _bCursorX, _bCursorY );
	vSetText( _bFGColor, _bBGColor );

	vPrintString( _lpString );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDisplayCenteredString( int _bCursorY, const char *_lpString, int _bFgColor, int _bBgColor )
	{
	int    bStringLength = (int)strlen( _lpString );

	vPrintStringXY( (int)( ( wGetMaxX(  ) >> 1 ) - ( bStringLength >> 1 ) ), _bCursorY, _lpString, _bFgColor, _bBgColor );
	}



int    bBoxMatrix[_BOX_MAX_TYPES][8] =  {
                            {   0xC4, 0xB3, 0xDA, 0xBF, 0xC0, 0xD9  },
                            {   0xCD, 0xB3, 0xD5, 0xB8, 0xD4, 0xBE  },
                            {   0xC4, 0xBA, 0xD6, 0xB7, 0xD3, 0xBD  },
                            {   0xCD, 0xBA, 0xC9, 0xBB, 0xC8, 0xBC  }
                                        };

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDrawBorder( int _left, int _top, int _right, int _bottom, int _bType, int _bFGColor, int _bBGColor )
	{
	int	bRow,
			bCol;
			
	for( bRow = (int)(_top + 1); bRow < _bottom; bRow++ )
		{
        vPrintCharXY( _left, bRow, bBoxMatrix[_bType][_BOX_SIDE_CENTER], _bFGColor, _bBGColor );
        vPrintCharXY( _right, bRow, bBoxMatrix[_bType][_BOX_SIDE_CENTER], _bFGColor, _bBGColor );
		}

	for( bCol = (int)(_left + 1); bCol < _right; bCol++ )
		{
        vPrintCharXY( bCol, _top, bBoxMatrix[_bType][_BOX_TOP_CENTER], _bFGColor, _bBGColor );
        vPrintCharXY( bCol, _bottom, bBoxMatrix[_bType][_BOX_TOP_CENTER], _bFGColor, _bBGColor );
		}
		
    vPrintCharXY( _left, _top, bBoxMatrix[_bType][_BOX_TOP_LEFT], _bFGColor, _bBGColor );
    vPrintCharXY( _right, _top, bBoxMatrix[_bType][_BOX_TOP_RIGHT], _bFGColor, _bBGColor );
    vPrintCharXY( _left, _bottom, bBoxMatrix[_bType][_BOX_BOTTOM_LEFT], _bFGColor, _bBGColor );
    vPrintCharXY( _right, _bottom, bBoxMatrix[_bType][_BOX_BOTTOM_RIGHT], _bFGColor, _bBGColor );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void    vDrawBox( int _left, int _top, int _right, int _bottom, int _bType, int _bFGColor, int _bBGColor )
	{
	int	bRow,
			bCol;
			
	for( bRow = (int)(_top + 1); bRow < _bottom; bRow++ )
		{
        vPrintCharXY( _left, bRow, bBoxMatrix[_bType][_BOX_SIDE_CENTER], _bFGColor, _bBGColor );
        vPrintCharXY( _right, bRow, bBoxMatrix[_bType][_BOX_SIDE_CENTER], _bFGColor, _bBGColor );
		}

	for( bCol = (int)(_left + 1); bCol < _right; bCol++ )
		{
        vPrintCharXY( bCol, _top, bBoxMatrix[_bType][_BOX_TOP_CENTER], _bFGColor, _bBGColor );
        vPrintCharXY( bCol, _bottom, bBoxMatrix[_bType][_BOX_TOP_CENTER], _bFGColor, _bBGColor );
		}
		
    vPrintCharXY( _left, _top, bBoxMatrix[_bType][_BOX_TOP_LEFT], _bFGColor, _bBGColor );
    vPrintCharXY( _right, _top, bBoxMatrix[_bType][_BOX_TOP_RIGHT], _bFGColor, _bBGColor );
    vPrintCharXY( _left, _bottom, bBoxMatrix[_bType][_BOX_BOTTOM_LEFT], _bFGColor, _bBGColor );
    vPrintCharXY( _right, _bottom, bBoxMatrix[_bType][_BOX_BOTTOM_RIGHT], _bFGColor, _bBGColor );


    for( bRow= (int)(_top + 1); bRow < _bottom; bRow++ )
		{
        for( bCol= (int)( _left + 1 ); bCol < _right; bCol++ )
			{
            vPrintCharXY( bCol, bRow, ' ', _bFGColor, _bBGColor );
			}
		}

    }
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vFillBox( int _left, int _top, int _right, int _bottom, int _bFillChar, int _bFGColor, int _bBGColor )
	{
	int	bRow,
			bCol;
			
	for( bRow= _top; bRow < _bottom+1; bRow++ )
		{
		for( bCol=_left; bCol < _right+1; bCol++ )
			{
			vPrintCharXY( bCol, bRow, _bFillChar, _bFGColor, _bBGColor );
			}
		}
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vDisplayOption( int _bCol, int _bRow, PMENU _sMenu, int _bSelect, int _bColor )
	{
	char 	szTmpStr[40] = "                                       ";
	
	int	bStrLen,
			bOffset = 0;
	
	
	bStrLen = (int)strlen( _sMenu->Option[_bSelect].szOption );
	
	strnset( szTmpStr, ' ', _sMenu->bMaxLength );
	szTmpStr[_sMenu->bMaxLength] = '\x0';

	switch( _sMenu->bAlign )
		{
		case _ALIGN_LEFT:
			bOffset = 0;
			break;

		case _ALIGN_CENTER:
			bOffset = (int)( ( _sMenu->bMaxLength - bStrLen ) >> 1 );
			break;

		case _ALIGN_RIGHT:
			bOffset = (int)( _sMenu->bMaxLength - bStrLen );
			break;
    	}

	strncpy( &szTmpStr[ bOffset ], _sMenu->Option[_bSelect].szOption, bStrLen );

	switch( _bColor )
		{
		case _NORMAL:
			vPrintStringXY( _bCol, _bRow, szTmpStr, _sMenu->sText.bFGColor, _sMenu->sText.bBGColor );
			vPutColorXY( (int)(_bCol + _sMenu->Option[_bSelect].bHotKeyIndex + bOffset), _bRow, _sMenu->sHighLight.bFGColor, _sMenu->sHighLight.bBGColor );
			break;
			
		case _HIGHLIGHT:
			vPrintStringXY( _bCol, _bRow, szTmpStr, _sMenu->sMenuBar.bFGColor, _sMenu->sMenuBar.bBGColor );
			break;
		}
	}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
int		iDisplayMenu( int _bCol, int _bRow, PMENU _sMenu, int _bSelect )
	{
	int	bRetVal = _bSelect,
			bSelected,
			bIndex,
			bInKey = 0,
			bCount;
    
    
	_sMenu->bMaxLength = (int)strlen( (char *)_sMenu->szMenuTitle );
    
    
	for( bCount=0; _sMenu->Option[bCount].szOption[0] != '\x0'; bCount++ )
		{
		if( strlen( _sMenu->Option[bCount].szOption ) > (BYTE)_sMenu->bMaxLength )
			{
			_sMenu->bMaxLength = (int)strlen( _sMenu->Option[bCount].szOption );
			}
		}
        
	for( bIndex=0; bIndex < bCount; bIndex++ )
		{
		vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + bIndex + 1), _sMenu, bIndex, _NORMAL );
		}

    /* Draw Menu Border */
    vDrawBorder( _bCol, _bRow, (int)(_bCol + 1 + _sMenu->bMaxLength), (int)(_bRow + bIndex + 1), _BOX_SINGLE, _sMenu->sBorder.bFGColor, _sMenu->sBorder.bBGColor );

	/* Display Menu Title */
	vPrintStringXY( (int)(_bCol + 1 + ( _sMenu->bMaxLength >> 1 ) - ( strlen( (char *)_sMenu->szMenuTitle ) >> 1 ) ), _bRow, (char *)_sMenu->szMenuTitle, _sMenu->sTitle.bFGColor, _sMenu->sTitle.bBGColor );

	vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + _bSelect + 1 ), _sMenu, _bSelect, _HIGHLIGHT );

	bSelected = _bSelect;
	do
		{
		if( kbhit() )
			{
			bInKey = (int)getch();
			switch( bInKey )
				{
				case 0x48:	/* up arrow */
					if( bSelected > 0 )
						{
						vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + bSelected + 1 ), _sMenu, bSelected, _NORMAL );
						--bSelected;
						vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + bSelected + 1 ), _sMenu, bSelected, _HIGHLIGHT );
						}
					break;
					
				case 0x50:	/* down arrow */
					if( bSelected < ( bCount - 1 ) )
						{
						vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + bSelected + 1 ), _sMenu, bSelected, _NORMAL );
						++bSelected;
						vDisplayOption( (int)(_bCol + 1 ), (int)(_bRow + bSelected + 1 ), _sMenu, bSelected, _HIGHLIGHT );
						}
					break;
				
				case 0x4B:	/* left arrow */
					break;
					
				case 0x4D:	/* right arrow */
					break;
					
				case 0x0D:	/* return key */
					bRetVal = bSelected;
					bInKey = 0x1B;
					break;

				case 0x1B:
					bRetVal = _bSelect;
					break;
					
				case 0x00:
					break;
											
				default:
					vDisplayOption( (int)(_bCol + 1 ), (int)((int)(_bRow + 1 ) + bSelected), _sMenu, bSelected, _NORMAL );

					for( bIndex=0; bIndex < bCount + 1; bIndex++ )
						{
						if( tolower( _sMenu->Option[bIndex].szOption[_sMenu->Option[bIndex].bHotKeyIndex] ) == tolower( bInKey ) )
							{
							bSelected = bIndex;
							break;
							}
                        }
                        
					vDisplayOption( (int)(_bCol + 1 ), (int)((int)(_bRow + 1 ) + bSelected), _sMenu, bSelected, _HIGHLIGHT );
					break;
				}
			}
		}
	while( bInKey != 0x1B );

	return( bRetVal );
	}
		
	
