#define _NORMAL     0
#define	_HIGHLIGHT	1

#define _ALIGN_LEFT     0
#define	_ALIGN_CENTER	1
#define	_ALIGN_RIGHT	2

#define _BOX_SINGLE         0
#define _BOX_DOUBLE_TOP     1
#define _BOX_DOUBLE_SIDE    2
#define _BOX_DOUBLE         3

#define _BOX_MAX_TYPES      4

#define _BOX_TOP_CENTER     0
#define _BOX_SIDE_CENTER    1
#define _BOX_TOP_LEFT       2
#define _BOX_TOP_RIGHT      3
#define _BOX_BOTTOM_LEFT    4
#define _BOX_BOTTOM_RIGHT   5

#define _TXT_BLACK          ((int)0x00)
#define _TXT_BLUE           ((int)0x01)
#define _TXT_GREEN          ((int)0x02)
#define _TXT_CYAN           ((int)0x03)
#define _TXT_RED            ((int)0x04)
#define _TXT_MAGENTA        ((int)0x05)
#define _TXT_BROWN          ((int)0x06)
#define _TXT_WHITE          ((int)0x07)

#define _TXT_GRAY           ((int)0x08)
#define _TXT_BRIGHT_BLUE    ((int)0x09)
#define _TXT_BRIGHT_GREEN   ((int)0x0A)
#define _TXT_BRIGHT_CYAN    ((int)0x0B)
#define _TXT_BRIGHT_RED     ((int)0x0C)
#define _TXT_BRIGHT_MAGENTA ((int)0x0D)
#define _TXT_YELLOW         ((int)0x0E)
#define _TXT_BRIGHT_WHITE   ((int)0x0F)

typedef	struct	_OPTION	{
	int	bHotKeyIndex;
	char	szOption[80];
	}OPTION, *POPTION, far *LPOPTION;
            
typedef struct	_SCRCOLOR	{
	int	bFGColor,
			bBGColor;
	}SCRCOLOR, *PSCRCOLOR, *LPSCRCOLOR;
	
typedef struct	_MENU	{
	int		szMenuTitle[80];

	int		bRow,
				bCol;
				
	SCRCOLOR	sTitle,
				sBorder,
				sText,
				sHighLight,
				sMenuBar;

	POPTION		Option;
	int		bAlign;
	int		bMaxLength;
	}MENU, *PMENU, far *LPMENU;

#define	_BYTE_DISPLAY	0
#define	_WORD_DISPLAY	1
#define	_STRING_DISPLAY	2

extern	BYTE	gbCenterX,
				gbCenterY;
				
int    bGetVideoMode( void );
void	SetVideoMode( BYTE _bVideoMode );

void	vSetVideoPage( BYTE _bVideoPage );
BYTE	bGetVideoPage( void );

void	vSetCursorStartLine( BYTE _bCursorStartLine );
BYTE	bGetCursorStartLine( void );

void    vSetCursorEndLine( BYTE _bCursorEndLine );
BYTE	bGetCursorEndLine( void );

WORD    wGetCursorSize( void );
void    vSetCursorSize( BYTE _bBeginScanLine, BYTE _bEndScanLine );

void    vDisableCursor( void );
void    vEnableCursor( void );

WORD    wGetCursorPosition( void );
void    vSetCursorPosition( int _bCursorX, int _bCursorY );

int    bGetCursorX( void );
void    vSetCursorY( int _bCursorY );

int    bGetCursorY( void );
void    vSetCursorX( int _bCursorX );

int    bGetChar( void );
void    vPutChar( BYTE _bChar );

int    bGetColor( void );
void    vPutColor( BYTE _bColor );

WORD	wGetMaxX( void );
WORD	wGetMaxY( void );

void    vClearScreen( void );

int    bGetCharXY( int _bCursorX, int _bCursorY );
void    vPutCharXY( int _bCursorX, int _bCursorY, const char _bChar, int _bFGColor, int _bBGColor );

void    vSetTextColor( int _bFGColor, int _bBGColor );
int    bGetTextColor( void );

void    vPrintChar( char _bChar );
void    vPrintString( const char * _lpString );

void	vPutColorXY( int _bCursorX, int _bCursorY, int _bFGColor, int _bBGColor );
int	bGetColorXY( int _bCursorX, int _bCursorY );

void    vPrintCharXY( int _bCursorX, int _bCursorY, int _bChar, int _bFGColor, int _bBGColor );
void    vPrintStringXY( int _bCursorX, int _bCursorY, const char *_lpString, int _bFGColor, int _bBGColor );

void    vDrawBorder( int _left, int _top, int _right, int _bottom, int _bType, int _bFGColor, int _bBGColor );
void	vFillBox( int _left, int _top, int _right, int _bottom, int _bFillChar, int _bFGColor, int _bBGColor );
void	vDrawBox( int _left, int _top, int _right, int _bottom, int _bFillChar, int _bFGColor, int _bBGColor );

int		iDisplayMenu( int _bCol, int _bRow, PMENU _sMenu, int _bSelect );

void	vDisplayOption( int _bCol, int _bRow, PMENU _sMenu, int _bSelect, int _bColor );

void    vDisplayCenteredString( int _bCursorY, const char *_lpString, int _bFgColor, int _bBgColor );
