#include	<stdlib.h>
#include	<stdio.h>
#include	<graph.h>

#include	"stdtype.h"
#include	"screenio.h"
#include	"display.h"
#include	"config.h"

#include    "setup.h"

BYTE		gbCenterY, 
			gbCenterX;

OPTION  EnableMenu[] =
    {
    {0, "Disable Test"},
    {0, "Enable Test"},
    {0, ""}
    };


/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIOPCI( void )
	{
    int bIndex;

    for( bIndex=0; _io_pci_choices[bIndex] != -1; bIndex++ )
    	if( gwIOPCI == (WORD)_io_pci_choices[bIndex] )
    		break;

	if( _io_pci_choices[bIndex] == -1 )
		gwIOPCI = DEFAULT_IO_PCI;

	gwIOPCI = (WORD)iDisplayIntOptions( gbCenterX, gbCenterY, "Select DDMA Base I/O", _io_pci_choices, (BYTE)bIndex, 1, _ALIGN_CENTER, _WORD_DISPLAY );
	}
	
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIRQPCI( void )
	{     
    int bIndex;

    for( bIndex=0; _irq_audio_choices[bIndex] != -1; bIndex++ )
    	if( gbIRQAudio == _irq_audio_choices[bIndex] )
    		break;

	if( _irq_audio_choices[bIndex] == -1 )
		gbIRQAudio = DEFAULT_IRQ_AUDIO;

	gbIRQAudio = (BYTE)iDisplayIntOptions( gbCenterX, gbCenterY, "Select Interrupt", _irq_audio_choices, (BYTE)bIndex, 1, _ALIGN_CENTER, _BYTE_DISPLAY );
	}

/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIOAudio( void )
	{
    int bIndex;

    for( bIndex=0; _io_audio_choices[bIndex] != -1; bIndex++ )
    	if( gwIOAudio == (WORD)_io_audio_choices[bIndex] )
    		break;

	if( _io_audio_choices[bIndex] == -1 )
		gwIOAudio = DEFAULT_IO_AUDIO;

	gwIOAudio = (WORD)iDisplayIntOptions( gbCenterX, gbCenterY, "Select Base I/O Address", _io_audio_choices, (BYTE)bIndex, 1, _ALIGN_CENTER, _WORD_DISPLAY );
	}
	
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIOFMSynth( void )
	{
    int bIndex;

    for( bIndex=0; _io_fmsynth_choices[bIndex] != -1; bIndex++ )
    	if( gwIOFMSynth == (WORD)_io_fmsynth_choices[bIndex] )
    		break;

	if( _io_fmsynth_choices[bIndex] == -1 )
		gwIOFMSynth = DEFAULT_IO_FMSYNTH;

	gwIOFMSynth = (WORD)iDisplayIntOptions( gbCenterX, gbCenterY, "Select FM Base I/O", _io_fmsynth_choices, (BYTE)bIndex, 3, _ALIGN_CENTER, _WORD_DISPLAY );
	}
	
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIOMPU401( void )
	{
	int bIndex;

    for( bIndex=0; _io_mpu401_choices[bIndex] != -1; bIndex++ )
    	if( gwIOMPU401 == (WORD)_io_mpu401_choices[bIndex] )
    		break;

	if( _io_mpu401_choices[bIndex] == -1 )
		gwIOMPU401 = DEFAULT_IO_MPU401;

	gwIOMPU401 = (WORD)iDisplayIntOptions( gbCenterX, gbCenterY, "Select MPU401 Base I/O", _io_mpu401_choices, (BYTE)bIndex, 3, _ALIGN_CENTER, _WORD_DISPLAY );
    }

/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/
void	vSelectIOJoystick( void )
	{
    int bIndex;

    for( bIndex=0; _io_joystick_choices[bIndex] != -1; bIndex++ )
    	if( gwIOJoystick == (WORD)_io_joystick_choices[bIndex] )
    		break;

	if( _io_joystick_choices[bIndex] == -1 )
		gwIOJoystick = DEFAULT_IO_JOYSTICK;

	gwIOJoystick = (WORD)iDisplayIntOptions( gbCenterX, gbCenterY, "Select Joystick Base I/O", _io_joystick_choices, (BYTE)bIndex, 3, _ALIGN_CENTER, _WORD_DISPLAY );
	}
	
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void	vConfigureSetup()
    {
    vDisplayConfig();
    vSelectIOPCI();

    vDisplayConfig();
    vSelectIRQPCI();
    
    vDisplayConfig();
    vSelectIOAudio();

//    vDisplayConfig();
//    vSelectIOFMSynth();

    vDisplayConfig();
	vSelectIOMPU401();

    vDisplayConfig();
	vSelectIOJoystick();

    vDisplayConfig();
    flgTestMic = (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY,  "Select Mic Test Option" , EnableMenu, flgTestMic, _ALIGN_CENTER );

    vDisplayConfig();
    flgTestLineIn = (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY, "Select Line-In Test Option", EnableMenu, flgTestLineIn, _ALIGN_CENTER );

    vDisplayConfig();
    flgTestCDLineIn = (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY, "Select CD Line-In Test Option", EnableMenu, flgTestCDLineIn, _ALIGN_CENTER );

    vDisplayConfig();
    flgTestMonoIn= (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY,  "Select MonoIn Test Option", EnableMenu, flgTestMonoIn, _ALIGN_CENTER );

    vDisplayConfig();
    flgTestMPU401 = (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY, "Select MPU401 Test Option", EnableMenu, flgTestMPU401, _ALIGN_CENTER );
		
    vDisplayConfig();
    flgTestJoystick = (BYTE)iDisplayStringOptions( gbCenterX, gbCenterY, "Select Joystick Test Option", EnableMenu, flgTestJoystick, _ALIGN_CENTER );

	if( flgTestMPU401 )
		{
		vDisplayConfig();
		vSelectIOMPU401();
		}
	
	if( flgTestJoystick )
		{
//        vDisplayConfig();
//        vSelectIOJoystick();
		}

   	vClearScreen();

    bWrConfigFile( _CONFIG_FILE_NAME );
	}

